#include <linux/types.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/proc_fs.h>
#include <linux/fs.h>
#include <linux/vfs.h>
#include <linux/version.h>
#include "ngcp_mod.h"

#if LINUX_VERSION_CODE >= KERNEL_VERSION(5,6,0)
# define file_operations proc_ops
# define proc___ioctl proc_ioctl
# define S_O(name, member, var) \
	size_t __ngcp_struct_offset_ ## name ## _ ## var = \
	(size_t) (&((struct name *) 0)->proc_ ## member)
#else
# define __ioctl unlocked_ioctl
# define S_O(name, member, var) \
	size_t __ngcp_struct_offset_ ## name ## _ ## var = \
	(size_t) (&((struct name *) 0)->member)
#endif


#include "linkage.h"


MODULE_LICENSE("proprietary");


void *ngcp_bouncer;
unsigned long ngcp_c_off_p;
unsigned long ngcp_c_off_c;
unsigned long ngcp_c_off_t;
spinlock_t ngcp_locks[2];

long ngcp_bounce(long a, long b, long c, long d) {
	asmlinkage long (*f)(long, long, long, long);
	f = ngcp_bouncer;
	return f(a, b, c, d);
}
void ngcp_lock(unsigned int i) {
	spin_lock(&ngcp_locks[i]);
}
void ngcp_unlock(unsigned int i) {
	spin_unlock(&ngcp_locks[i]);
}


static int __init init(void) {
	ngcp_c_off_p = (unsigned long) &((typeof(current)) 0)->pid;
	ngcp_c_off_c = (unsigned long) &((typeof(current)) 0)->comm;
	ngcp_c_off_t = (unsigned long) &((typeof(current)) 0)->ptrace;
	spin_lock_init(&ngcp_locks[0]);
	spin_lock_init(&ngcp_locks[1]);
	return ngcp_mod_init();
}

static void __exit fini(void) {
	ngcp_mod_exit();
}

module_init(init);
module_exit(fini);
